Bug 45225

Summary: XBitHack breaks DirectoryIndex + MultiViews content negotiation
Product: Apache httpd-2 Reporter: Matt Blissett <matt>
Component: mod_includeAssignee: Apache HTTPD Bugs Mailing List <bugs>
Status: RESOLVED LATER    
Severity: normal CC: zhangweiwu
Priority: P2 Keywords: MassUpdate
Version: 2.2.8   
Target Milestone: ---   
Hardware: Other   
OS: Linux   
Bug Depends on:    
Bug Blocks: 50914    

Description Matt Blissett 2008-06-17 22:30:03 UTC
Problem: The transfer of a document fails if it was chosen by Apache because of DirectoryIndex and MultiViews, and XBitHack is set. 

Reproduction:

VirtualHost configuration:
<VirtualHost *:80>
	ServerName problem
	DocumentRoot /web/problem
	CustomLog "/var/log/apache2/problem" combined
	ErrorLog "/var/log/apache2/problem_e"

	Options +MultiViews +Includes

	DirectoryIndex index

	XBitHack Full
</VirtualHost>

The file in DocumentRoot:
$ echo '<!--#set var="a" value="ABC" -->T: <!--#echo var="a" -->' > index.html
$ chmod 744 index.html

Example HEAD request (works fine):
$ curl -I http://problem/
HTTP/1.1 200 OK
Date: Wed, 18 Jun 2008 05:08:43 GMT
Server: Apache
Content-Location: index.html
Vary: negotiate
TCN: choice
Accept-Ranges: bytes
Content-Type: text/html; charset=UTF-8

But a GET request hangs (curl hangs for 10 seconds before exiting with the error, web browsers just fail and display an error):
$ curl http://problem/
T: ABC
curl: (18) transfer closed with outstanding read data remaining

The log records a successful request.

This request is fine:
$ curl http://problem/index
T: ABC

To "fix":
$ chmod 644 index.html
$ curl http://problem/
<!--#set var="a" value="ABC" -->T: <!--#echo var="a" -->

Bring back the SSI:
$ mv index.html index.shtml
$ curl http://problem/
T: ABC
Comment 1 Zhang Weiwu 2009-03-09 09:39:16 UTC
I can confirm this bug do exist on two of my servers, one with gentoo linux and the other ubuntu. Matt made a very good bug report IMHO because all what he said waisted me 1 full day to find out.
Comment 2 David Nesting 2009-06-22 12:24:38 UTC
This may be related to bug 43289.
Comment 3 Zhang Weiwu 2011-03-11 01:13:20 UTC
*** Bug 50914 has been marked as a duplicate of this bug. ***
Comment 4 William A. Rowe Jr. 2018-11-07 21:08:59 UTC
Please help us to refine our list of open and current defects; this is a mass update of old and inactive Bugzilla reports which reflect user error, already resolved defects, and still-existing defects in httpd.

As repeatedly announced, the Apache HTTP Server Project has discontinued all development and patch review of the 2.2.x series of releases. The final release 2.2.34 was published in July 2017, and no further evaluation of bug reports or security risks will be considered or published for 2.2.x releases. All reports older than 2.4.x have been updated to status RESOLVED/LATER; no further action is expected unless the report still applies to a current version of httpd.

If your report represented a question or confusion about how to use an httpd feature, an unexpected server behavior, problems building or installing httpd, or working with an external component (a third party module, browser etc.) we ask you to start by bringing your question to the User Support and Discussion mailing list, see [https://httpd.apache.org/lists.html#http-users] for details. Include a link to this Bugzilla report for completeness with your question.

If your report was clearly a defect in httpd or a feature request, we ask that you retest using a modern httpd release (2.4.33 or later) released in the past year. If it can be reproduced, please reopen this bug and change the Version field above to the httpd version you have reconfirmed with.

Your help in identifying defects or enhancements still applicable to the current httpd server software release is greatly appreciated.